# ]po[ CSV Import
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](http://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](http://www.project-open.com/en/list-installers)

About ]po[ CSV Import:

<p>This package allows for comfortable import of data in CSV (Comma Separated Values) format into ]po[ objects for: <ul><li><a href="/en/object-type-im-project">Projects</a>,<li><a href="/en/object-type-im-company">Companies</a> and<li><a href="/en/object-type-user">Users</a>. </ul><p><img src="http://www.project-open.com/images/manual_screenshots/intranet_csv_import_mapping.png" />

# Online Reference Documentation

## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=1342730&amp;path=packages/intranet-csv-import/tcl/intranet-csv-import-parser-procs.tcl">tcl/intranet-csv-import-parser-procs.tcl</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=1342730&amp;path=packages/intranet-csv-import/tcl/intranet-csv-import-procs.tcl">tcl/intranet-csv-import-procs.tcl</a></b></td><td></td><td></td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=csv_norm">csv_norm</a></b></td><td></td><td>Performs normalization including trim, tolower, replace non-ascii with &quot;_&quot;. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_check_list_of_lists">im_csv_import_check_list_of_lists</a></b></td><td></td><td>Check that the parameter is a list of lists with all lines having the same length. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_budget_item">im_csv_import_guess_im_budget_item</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_company">im_csv_import_guess_im_company</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_conf_item">im_csv_import_guess_im_conf_item</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_expense">im_csv_import_guess_im_expense</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_expense_bundle">im_csv_import_guess_im_expense_bundle</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_hour">im_csv_import_guess_im_hour</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_invoice">im_csv_import_guess_im_invoice</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_project">im_csv_import_guess_im_project</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_risk">im_csv_import_guess_im_risk</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_ticket">im_csv_import_guess_im_ticket</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_im_timesheet_task">im_csv_import_guess_im_timesheet_task</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_map">im_csv_import_guess_map</a></b></td><td></td><td>Returns the best guess for a DynField for the field. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_parser">im_csv_import_guess_parser</a></b></td><td></td><td>Returns the best guess for a parser for the given field as a list with: &lt;ul&gt; &lt;li&gt;The parser name, &lt;li&gt;the parser args and &lt;li&gt;the field name to map to &lt;/ul&gt; </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_person">im_csv_import_guess_person</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_guess_rels">im_csv_import_guess_rels</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_label_from_object_type">im_csv_import_label_from_object_type</a></b></td><td></td><td>Returns the main navbar lable for the object_type </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_object_fields">im_csv_import_object_fields</a></b></td><td></td><td>Returns a list of database columns for the specified object type. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_boolean">im_csv_import_parser_boolean</a></b></td><td></td><td>Boolean - argument is mapped to SQL boolean: &#39;t&#39; or &#39;f&#39; </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_budget_item_parent_nrs">im_csv_import_parser_budget_item_parent_nrs</a></b></td><td></td><td>Returns a budget_item_id from a list of parent budget item numbers </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_category">im_csv_import_parser_category</a></b></td><td></td><td>Parses a category into a category_id </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_company_name">im_csv_import_parser_company_name</a></b></td><td></td><td>Returns a company_id from im_companies </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_conf_item_parent_nrs">im_csv_import_parser_conf_item_parent_nrs</a></b></td><td></td><td>Returns a conf_item_id from a list of conf_item Nrs. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_cost_center">im_csv_import_parser_cost_center</a></b></td><td></td><td>Parses a cost center into a cost_center_id </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_date">im_csv_import_parser_date</a></b></td><td></td><td>Generic date parser - front-end for all available date formats </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_date_american">im_csv_import_parser_date_american</a></b></td><td></td><td>Parses a American date format like &#39;12/31/2011&#39; as the 31st of December, 2011 </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_date_european">im_csv_import_parser_date_european</a></b></td><td></td><td>Parses a European date format like &#39;08.06.2011&#39; as the 8th of June, 2011 </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_date_european_slashes">im_csv_import_parser_date_european_slashes</a></b></td><td></td><td>Parses a European date format like &#39;08/06/2011&#39; as the 8th of June, 2011 </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_date_iso">im_csv_import_parser_date_iso</a></b></td><td></td><td>Parses ISO date format like &#39;2011-06-08&#39; as the 8th of June, 2011 </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_hard_coded">im_csv_import_parser_hard_coded</a></b></td><td></td><td>Empty parser - returns the argument </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_material">im_csv_import_parser_material</a></b></td><td></td><td>Parses a material name or nr into a material_id </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_no_change">im_csv_import_parser_no_change</a></b></td><td></td><td>Dummy parser without transformation </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_number">im_csv_import_parser_number</a></b></td><td></td><td>Parses a generic number. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_number_american">im_csv_import_parser_number_american</a></b></td><td></td><td>Validates a US number format </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_number_european">im_csv_import_parser_number_european</a></b></td><td></td><td>Parses a European number format like &#39;20.000,00&#39; as twenty thousand </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_office_name">im_csv_import_parser_office_name</a></b></td><td></td><td>Returns a office_id from im_companies </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_percentage">im_csv_import_parser_percentage</a></b></td><td></td><td>Parses a percentage number. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_project_name">im_csv_import_parser_project_name</a></b></td><td></td><td>Returns a project_id from project_name </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_project_nr">im_csv_import_parser_project_nr</a></b></td><td></td><td>Returns a project_id from project_nr </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_project_parent_nrs">im_csv_import_parser_project_parent_nrs</a></b></td><td></td><td>Returns a project_id from a list of project_nr&#39;s </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parser_user_name">im_csv_import_parser_user_name</a></b></td><td></td><td>Returns a user_id from parties </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=1342730&amp;proc=im_csv_import_parsers">im_csv_import_parsers</a></b></td><td></td><td>Returns the list of available parsers </td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-csv-import&amp;url=postgresql/upgrade/upgrade-5.0.2.0.0-5.0.2.0.1.sql&amp;version_id=1342730">sql/postgresql/upgrade/upgrade-5.0.2.0.0-5.0.2.0.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-csv-import&amp;url=postgresql/upgrade/upgrade-5.0.2.4.0-5.0.2.4.1.sql&amp;version_id=1342730">sql/postgresql/upgrade/upgrade-5.0.2.4.0-5.0.2.4.1.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td><b>examples/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_budget_item.csv">im_budget_item.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_company.csv">im_company.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_conf_item.csv">im_conf_item.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_expense.csv">im_expense.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_expense_bundle.csv">im_expense_bundle.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_hour.csv">im_hour.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_invoice.csv">im_invoice.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_project.csv">im_project.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_relation.csv">im_relation.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/im_risk.csv">im_risk.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/examples/person.csv">person.csv</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-2.adp">import-2.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-2.tcl">import-2.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_budget_item.tcl">import-im_budget_item.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_company.tcl">import-im_company.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_conf_item.tcl">import-im_conf_item.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_expense.tcl">import-im_expense.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_expense_bundle.tcl">import-im_expense_bundle.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_hour.tcl">import-im_hour.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_invoice.tcl">import-im_invoice.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_membership.tcl">import-im_membership.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_project.tcl">import-im_project.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_risk.tcl">import-im_risk.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-im_ticket.tcl">import-im_ticket.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-person.tcl">import-person.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/import-rels.tcl">import-rels.tcl</a></b></td><td>Starts the analysis process for the file imported</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/index.tcl">index.tcl</a></b></td><td>Serve the user a form to upload a new file or URL</td></tr><tr valign="top"><td><b>reports/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=1342730&amp;path=packages/intranet-csv-import/www/reports/export-projects.tcl">export-projects.tcl</a></b></td><td>Report listing all main projects in the system with all available fields + DynFields from projects and customers</td></tr></table>

